﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EnemiesController : MonoBehaviour {

    GameObject player;
    bool trapActivated = false;
    AudioSource _audio;

    public AudioClip[] audios;


    void Start()
    {
        player = GameObject.FindGameObjectWithTag("Player");
        _audio = GetComponent<AudioSource>();
    }

    public void CheckDistance(bool status)
    {
        trapActivated = status;
        if(player == null)
        {
            Debug.Log("No player found");
            return;
        }
            
        if(Vector3.Distance(player.transform.position, transform.position) < 4 || trapActivated)
        {
            Vector3 dir = player.transform.position - transform.position;
            transform.Translate(dir.normalized * 5.3f * Time.deltaTime);
        }
    }

    void Acercarse(Vector3 target)
    {
        Vector3 dir = target - transform.position;
        transform.Translate(dir * 2 *Time.deltaTime);
        Talk();
    }
    void OnTriggerEnter(Collider other)
    {
        if(other.gameObject.tag == "Wave")
        {
            Acercarse(other.transform.position);
        }
        if (other.gameObject.tag == "Player")
            player.GetComponent<PlayerController>().Muerte();
    }

    public void Talk()
    {
        if (!_audio.isPlaying)
        {
            _audio.clip = audios[Random.Range(0, 2)];
            _audio.Play();
        }
        
    }
}
