﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerController : MonoBehaviour
{
    GameManager.Directions dir;
    Camera mainCamera;
    float timer;
    int steps;
    GameObject wavePrefab;
    GameObject wave;
    bool dead = false;
    AudioSource _audio;
    public AudioClip[] audios;

    public void SetAlive()
    {
        dead = false;
    }

    void Start()
    {
        mainCamera = Camera.main;
        wavePrefab = Resources.Load<GameObject>("Prefabs/Wave");
        _audio = GetComponent<AudioSource>();
    }

    void Update()
    {
        mainCamera.transform.LookAt(gameObject.transform);
        if (!dead && GameManager.gManager.GetLevelReady())
        {
            if (Input.GetKey(KeyCode.UpArrow) || Input.GetKey(KeyCode.W))
            {
                transform.Translate(0, 0, 1 * 5 * Time.deltaTime);
                timer += Time.deltaTime;
                if (timer > 0.5)
                {
                    _audio.clip = audios[0];
                    _audio.Play();
                    steps++;
                    wave = Instantiate(wavePrefab, transform);
                    wave.transform.localPosition = new Vector3(0, -0.4f, 0);
                    wave.transform.SetParent(transform.parent);
                    timer = 0;
                }
            }

            if (Input.GetKey(KeyCode.DownArrow) || Input.GetKey(KeyCode.S))
            {
                transform.Translate(0, 0, -1 * 5 * Time.deltaTime);
                timer += Time.deltaTime;
                if (timer > 0.5)
                {
                    _audio.clip = audios[0];
                    _audio.Play();
                    steps++;
                    wave = Instantiate(wavePrefab, transform);
                    wave.transform.localPosition = new Vector3(0, -0.4f, 0);
                    wave.transform.SetParent(transform.parent);
                    timer = 0;
                }
            }
            if (Input.GetKey(KeyCode.LeftArrow) || Input.GetKey(KeyCode.A))
            {
                dir = GameManager.Directions.LEFT;
                Mover(dir);
            }
            if (Input.GetKey(KeyCode.RightArrow) || Input.GetKey(KeyCode.D))
            {
                dir = GameManager.Directions.RIGHT;
                Mover(dir);
            }
        }
    }

    public void Mover(GameManager.Directions dir)
    {
        switch (dir)
        {
            case GameManager.Directions.LEFT:
                {
                    transform.Rotate(new Vector3(0, -5, 0));
                    break;
                }
            case GameManager.Directions.RIGHT:
                {
                    transform.Rotate(new Vector3(0, 5, 0));
                    break;
                }
        }
    }

    public void Muerte()
    {
        dead = true;
        GameManager.gManager.Lose();
        Debug.Log("Muerto");
    }

    void OnCollisionEnter(Collision other)
    {
        Debug.Log(other.gameObject.name);
        if(other.gameObject.tag == "Exit")
        {
            Debug.Log("You WIN");
            GameManager.gManager.LevelComplete();
            _audio.clip = audios[2];
            _audio.Play();
        }
        if(other.gameObject.tag == "Trap")
        {
            GameManager.gManager.SetTrapActivated(true);
            GameObject trapWave = Instantiate(wavePrefab, transform);
            trapWave.transform.localPosition = new Vector3(0, 0, 0);
            trapWave.transform.SetParent(transform.parent);
            trapWave.GetComponent<Renderer>().material.SetColor("_EmissionColor", Color.red);
            _audio.PlayOneShot(audios[1]);
        }
    }
}
